;;; Sierra Script 1.0 - (do not remove this comment)
(script# 952)
(include game.sh)
(use Main)
(use Print)
(use PolyPath)
(use System)

(public
	sysLogger 0
)

(local
	logHandle
)
(procedure (localproc_0010 param1 param2 param3 &tmp [temp0 40] temp40 temp41)
	(Format @temp0 {%15s:_} param2)
	(FileIO fileFPuts logHandle @temp0)
	(= temp0 0)
	(switch param1
		(1
			(StrCpy @temp0 (if param3 else {}))
		)
		(2 (Format @temp0 {%d} param3))
		(3 (Format @temp0 {%u} param3))
		(4 (Format @temp0 {%x} param3))
		(5
			(if param3 (GetInput @temp0 66 param3 999))
			(= temp41 (StrLen @temp0))
		)
		(6
			(= temp40 (GetTime 2))
			(Format
				@temp0
				{%02d:%02d:%02d}
				(>> temp40 $000b)
				(& (>> temp40 $0005) $003f)
				(* (& temp40 $001f) 2)
			)
		)
		(7
			(= temp40 (GetTime 3))
			(Format
				@temp0
				{%02d/%02d/%02d}
				(& (>> temp40 $0005) $000f)
				(& temp40 $001f)
				(+ 80 (>> temp40 $0009))
			)
		)
	)
	(StrCat @temp0 {\0D\n})
	(FileIO fileFPuts logHandle @temp0)
	(return temp41)
)

(instance sysLogger of Code
	(properties)
	
	(method (doit &tmp temp0 temp1 temp2 temp3 temp4 temp5 temp6 temp7 [temp8 40] [temp48 30] [temp78 30] [temp108 30] [temp138 20] [temp158 40] [temp198 40] [temp238 40] [temp278 40] [temp318 40] [temp358 40])
		(asm
			lag      inputFont
			sat      temp7
			ldi      999
			sag      inputFont
			ldi      0
			sat      temp358
			sat      temp318
			sat      temp278
			sat      temp238
			sat      temp198
			sat      temp158
			sat      temp108
			sat      temp78
			sat      temp8
			pushi    0
			pushi    1
			lea      @sysLogPath
			push    
			callk    StrLen,  2
			eq?     
			sat      temp4
			bnt      code_01bf
code_0178:
			pushi    0
			pushi    1
			lea      @temp78
			push    
			callk    StrLen,  2
			lt?     
			bnt      code_0188
			pprev   
			ldi      19
			lt?     
code_0188:
			not     
			bnt      code_01b0
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lofsa    {Enter drive letter, path, and your name\n(no extension, max 40 characters)}
			push    
			pushi    207
			pushi    4
			lea      @temp78
			push    
			pushi    40
			pushi    0
			pushi    20
			pushi    110
			pushi    0
			class    Print
			send     28
			jmp      code_0178
code_01b0:
			pushi    3
			lea      @sysLogPath
			push    
			lea      @temp78
			push    
			pushi    40
			callk    StrCpy,  6
code_01bf:
			pushi    3
			lea      @temp78
			push    
			lofsa    {%s.mem}
			push    
			lea      @sysLogPath
			push    
			callk    Format,  6
			pushi    65535
			pushi    3
			pushi    0
			lea      @temp78
			push    
			pushi    1
			callk    FileIO,  6
			sal      logHandle
			ne?     
			bnt      code_0209
			pushi    4
			pushi    5
			lea      @temp138
			push    
			pushi    80
			lsl      logHandle
			callk    FileIO,  8
			pushi    4
			pushi    5
			lea      @temp48
			push    
			pushi    80
			lsl      logHandle
			callk    FileIO,  8
			pushi    2
			pushi    1
			lsl      logHandle
			callk    FileIO,  4
			jmp      code_0219
code_0209:
			ldi      0
			sat      temp138
			pushi    2
			lea      @temp48
			push    
			lofsa    {resource.cfg}
			push    
			callk    StrCpy,  4
code_0219:
			lat      temp4
			bnt      code_024c
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lofsa    {Enter your login name\n(max 8 characters):}
			push    
			pushi    207
			pushi    4
			lea      @temp138
			push    
			pushi    12
			pushi    0
			pushi    20
			pushi    110
			pushi    0
			class    Print
			send     28
			pushi    3
			lea      @temp138
			push    
			pushi    8
			pushi    0
			callk    StrAt,  6
code_024c:
			lat      temp4
			not     
			bt       code_0276
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lofsa    {Enter configuration file name\n(or hit return to skip):}
			push    
			pushi    207
			pushi    4
			lea      @temp48
			push    
			pushi    30
			pushi    0
			pushi    20
			pushi    110
			pushi    0
			class    Print
			send     28
			bnt      code_02a0
code_0276:
			pushi    65535
			pushi    3
			pushi    0
			lea      @temp48
			push    
			pushi    1
			callk    FileIO,  6
			sal      logHandle
			eq?     
			bnt      code_02a0
			pushi    2
			lea      @temp48
			push    
			pushi    0
			callk    StrAt,  4
			bnt      code_02a0
			pushi    3
			lea      @temp48
			push    
			pushi    0
			pushi    0
			callk    StrAt,  6
			jmp      code_024c
code_02a0:
			pushi    65535
			lal      logHandle
			ne?     
			bnt      code_043a
code_02a8:
			pushi    4
			pushi    5
			lea      @temp8
			push    
			pushi    80
			lsl      logHandle
			callk    FileIO,  8
			bnt      code_0433
			ldi      0
			sat      temp0
code_02be:
			pushi    2
			lea      @temp8
			push    
			lst      temp0
			callk    StrAt,  4
			sat      temp3
			bnt      code_02df
			pushi    3
			push    
			pushi    9
			pushi    32
			calle    OneOf,  6
			bnt      code_02df
			+at      temp0
			jmp      code_02be
code_02df:
			ldi      0
			sat      temp1
code_02e3:
			pushi    2
			lea      @temp8
			push    
			lst      temp0
			callk    StrAt,  4
			sat      temp3
			bnt      code_0318
			pushi    5
			push    
			pushi    61
			pushi    58
			pushi    9
			pushi    32
			calle    OneOf,  10
			not     
			bnt      code_0318
			pushi    3
			lea      @temp108
			push    
			lst      temp1
			lst      temp3
			callk    StrAt,  6
			+at      temp0
			+at      temp1
			jmp      code_02e3
code_0318:
			pushi    3
			lea      @temp108
			push    
			lst      temp1
			pushi    0
			callk    StrAt,  6
			pushi    0
			pushi    2
			lea      @temp108
			push    
			lofsa    {kbdDrv}
			push    
			callk    StrCmp,  4
			eq?     
			bnt      code_033a
			lea      @temp158
			jmp      code_03a7
code_033a:
			pushi    0
			pushi    2
			lea      @temp108
			push    
			lofsa    {joyDrv}
			push    
			callk    StrCmp,  4
			eq?     
			bnt      code_034f
			lea      @temp198
			jmp      code_03a7
code_034f:
			pushi    0
			pushi    2
			lea      @temp108
			push    
			lofsa    {videoDrv}
			push    
			callk    StrCmp,  4
			eq?     
			bnt      code_0364
			lea      @temp238
			jmp      code_03a7
code_0364:
			pushi    0
			pushi    2
			lea      @temp108
			push    
			lofsa    {soundDrv}
			push    
			callk    StrCmp,  4
			eq?     
			bnt      code_037b
			lea      @temp278
			jmp      code_03a7
code_037b:
			pushi    0
			pushi    2
			lea      @temp108
			push    
			lofsa    {mouseDrv}
			push    
			callk    StrCmp,  4
			eq?     
			bnt      code_0392
			lea      @temp318
			jmp      code_03a7
code_0392:
			pushi    0
			pushi    2
			lea      @temp108
			push    
			lofsa    {audioDrv}
			push    
			callk    StrCmp,  4
			eq?     
			bnt      code_03a7
			lea      @temp358
code_03a7:
			sat      temp5
			bnt      code_02a8
code_03ac:
			pushi    2
			lea      @temp8
			push    
			lst      temp0
			callk    StrAt,  4
			sat      temp3
			bnt      code_03d1
			pushi    5
			push    
			pushi    61
			pushi    58
			pushi    9
			pushi    32
			calle    OneOf,  10
			bnt      code_03d1
			+at      temp0
			jmp      code_03ac
code_03d1:
			lat      temp0
			sat      temp1
			ldi      0
			sat      temp2
code_03d9:
			pushi    2
			lea      @temp8
			push    
			lst      temp1
			callk    StrAt,  4
			sat      temp3
			bnt      code_0411
			pushi    4
			push    
			pushi    58
			pushi    92
			pushi    47
			calle    OneOf,  8
			bnt      code_03ff
			lst      temp1
			ldi      1
			add     
			sat      temp0
code_03ff:
			lst      temp3
			ldi      46
			eq?     
			bnt      code_040d
			lst      temp1
			lat      temp0
			sub     
			sat      temp2
code_040d:
			+at      temp1
			jmp      code_03d9
code_0411:
			lst      temp2
			ldi      0
			eq?     
			bnt      code_041f
			lst      temp1
			lat      temp0
			sub     
			sat      temp2
code_041f:
			pushi    3
			lst      temp5
			lea      @temp8
			push    
			lat      temp0
			add     
			push    
			lst      temp2
			callk    StrCpy,  6
			jmp      code_02a8
code_0433:
			pushi    2
			pushi    1
			lsl      logHandle
			callk    FileIO,  4
code_043a:
			pushi    3
			lea      @temp78
			push    
			lofsa    {%s.log}
			push    
			lea      @sysLogPath
			push    
			callk    Format,  6
			lat      temp4
			bnt      code_04c6
			pushi    65535
			pushi    3
			pushi    0
			lea      @temp78
			push    
			pushi    1
			callk    FileIO,  6
			sal      logHandle
			eq?     
			bt       code_04b0
			pushi    3
			lea      @temp8
			push    
			lofsa    {Log file "%s" exists}
			push    
			lea      @temp78
			push    
			callk    Format,  6
			bnt      code_0479
			ldi      0
			bt       code_04b0
code_0479:
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lea      @temp8
			push    
			pushi    212
			pushi    4
			pushi    0
			lofsa    {Append to it}
			push    
			pushi    0
			pushi    12
			pushi    212
			pushi    4
			pushi    1
			lofsa    {Overwrite it}
			push    
			pushi    75
			pushi    12
			pushi    211
			pushi    1
			pushi    1
			pushi    110
			pushi    0
			class    Print
			send     46
			bnt      code_04c6
code_04b0:
			pushi    2
			pushi    1
			lsl      logHandle
			callk    FileIO,  4
			pushi    3
			pushi    0
			lea      @temp78
			push    
			pushi    2
			callk    FileIO,  6
			sal      logHandle
			jmp      code_04d3
code_04c6:
			pushi    3
			pushi    0
			lea      @temp78
			push    
			pushi    0
			callk    FileIO,  6
			sal      logHandle
code_04d3:
			pushi    65535
			lal      logHandle
			eq?     
			bnt      code_04f6
			pushi    #font
			pushi    1
			pushi    999
			pushi    206
			pushi    2
			lofsa    {Error: Couldn't open %s}
			push    
			lea      @temp78
			push    
			pushi    110
			pushi    0
			class    Print
			send     18
			jmp      code_09d8
code_04f6:
			pushi    3
			pushi    1
			lofsa    {GAME}
			push    
			pushi    #name
			pushi    0
			lag      theGame
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {VERSION}
			push    
			lsg      version
			call     localproc_0010,  6
			pushi    2
			pushi    7
			lofsa    {QA-DATE}
			push    
			call     localproc_0010,  4
			pushi    3
			pushi    1
			lofsa    {ANALYST}
			push    
			lea      @temp138
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {SEVERITY}
			push    
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lofsa    {Severity of bug...}
			push    
			pushi    212
			pushi    4
			lofsa    {Fatal}
			push    
			lofsa    {FATAL}
			push    
			pushi    0
			pushi    12
			pushi    212
			pushi    4
			lofsa    {Moderate}
			push    
			lofsa    {MODERATE}
			push    
			pushi    40
			pushi    12
			pushi    212
			pushi    4
			lofsa    {Minor}
			push    
			lofsa    {MINOR}
			push    
			pushi    100
			pushi    12
			pushi    211
			pushi    1
			pushi    1
			pushi    110
			pushi    0
			class    Print
			send     58
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {REPRODUCIBLE}
			push    
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lofsa    {Reproducible?}
			push    
			pushi    212
			pushi    4
			lofsa    {Yes}
			push    
			lofsa    {YES}
			push    
			pushi    0
			pushi    12
			pushi    212
			pushi    4
			lofsa    {No}
			push    
			lofsa    {NO}
			push    
			pushi    40
			pushi    12
			pushi    212
			pushi    4
			lofsa    {Intermittent}
			push    
			lofsa    {INTERMITTENT}
			push    
			pushi    80
			pushi    12
			pushi    211
			pushi    1
			pushi    1
			pushi    110
			pushi    0
			class    Print
			send     58
			push    
			call     localproc_0010,  6
			ldi      1
			sat      temp0
			ldi      1
			sat      temp6
code_05e8:
			lst      temp0
			ldi      10
			le?     
			bnt      code_0637
			pushi    3
			lea      @temp108
			push    
			lofsa    {QA-COMMENT%d}
			push    
			lst      temp0
			callk    Format,  6
			pushi    4
			lea      @temp8
			push    
			lofsa    {Comment line %d of %d:}
			push    
			lst      temp0
			pushi    10
			callk    Format,  8
			lat      temp6
			bnt      code_0627
			pushi    3
			pushi    5
			lea      @temp108
			push    
			lea      @temp8
			push    
			call     localproc_0010,  6
			sat      temp6
			jmp      code_0633
code_0627:
			pushi    3
			pushi    1
			lea      @temp108
			push    
			pushi    0
			call     localproc_0010,  6
code_0633:
			+at      temp0
			jmp      code_05e8
code_0637:
			pushi    3
			pushi    1
			lofsa    {DEPARTMENT}
			push    
			pushi    #font
			pushi    1
			pushi    999
			pushi    205
			pushi    1
			lofsa    {Who can fix bug...}
			push    
			pushi    212
			pushi    4
			lofsa    {Art}
			push    
			lofsa    {ART}
			push    
			pushi    0
			pushi    12
			pushi    212
			pushi    4
			lofsa    {Programming}
			push    
			lofsa    {PROG}
			push    
			pushi    40
			pushi    12
			pushi    212
			pushi    4
			lofsa    {Music}
			push    
			lofsa    {MUSIC}
			push    
			pushi    80
			pushi    12
			pushi    212
			pushi    4
			lofsa    {Design}
			push    
			lofsa    {DESIGN}
			push    
			pushi    120
			pushi    12
			pushi    211
			pushi    1
			pushi    1
			pushi    110
			pushi    0
			class    Print
			send     70
			push    
			call     localproc_0010,  6
			pushi    3
			lea      @temp8
			push    
			lofsa    {%04d}
			push    
			lsg      curRoomNum
			callk    Format,  6
			pushi    3
			pushi    1
			lofsa    {ROOM}
			push    
			lea      @temp8
			push    
			call     localproc_0010,  6
			pushi    #script
			pushi    0
			lag      curRoom
			send     4
			sat      temp0
			pushi    3
			pushi    1
			lofsa    {ROOM-SCRIPT}
			push    
			lat      temp0
			bnt      code_06d8
			pushi    #name
			pushi    0
			send     4
code_06d8:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {ROOM-STATE}
			push    
			lat      temp0
			bnt      code_06ed
			pushi    #state
			pushi    0
			send     4
code_06ed:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-X}
			push    
			pushi    #x
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-Y}
			push    
			pushi    #y
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-Z}
			push    
			pushi    #z
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    #script
			pushi    0
			lag      ego
			send     4
			sat      temp0
			pushi    3
			pushi    1
			lofsa    {EGO-SCRIPT}
			push    
			lat      temp0
			bnt      code_0743
			pushi    #name
			pushi    0
			send     4
code_0743:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-STATE}
			push    
			lat      temp0
			bnt      code_0758
			pushi    #state
			pushi    0
			send     4
code_0758:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-VIEW}
			push    
			pushi    #view
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-LOOP}
			push    
			pushi    #loop
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-CEL}
			push    
			pushi    #cel
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-PRIORITY}
			push    
			pushi    #priority
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-HEADING}
			push    
			pushi    #heading
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {CYCLER}
			push    
			pushi    #cycler
			pushi    0
			lag      ego
			send     4
			bnt      code_07d9
			pushi    #name
			pushi    0
			pushi    #cycler
			pushi    0
			lag      ego
			send     4
			send     4
code_07d9:
			push    
			call     localproc_0010,  6
			pushi    #mover
			pushi    0
			lag      ego
			send     4
			sat      temp0
			pushi    3
			pushi    1
			lofsa    {EGO-MOVER}
			push    
			lat      temp0
			bnt      code_07f7
			pushi    #name
			pushi    0
			send     4
code_07f7:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {MOVER-X}
			push    
			lat      temp0
			not     
			bnt      code_080c
			ldi      0
			jmp      code_0828
code_080c:
			pushi    #isMemberOf
			pushi    1
			class    PolyPath
			push    
			lat      temp0
			send     6
			bnt      code_0822
			pushi    #finalX
			pushi    0
			lat      temp0
			send     4
			jmp      code_0828
code_0822:
			pushi    #x
			pushi    0
			lat      temp0
			send     4
code_0828:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {MOVER-Y}
			push    
			lat      temp0
			not     
			bnt      code_083d
			ldi      0
			jmp      code_0859
code_083d:
			pushi    #isMemberOf
			pushi    1
			class    PolyPath
			push    
			lat      temp0
			send     6
			bnt      code_0853
			pushi    #finalY
			pushi    0
			lat      temp0
			send     4
			jmp      code_0859
code_0853:
			pushi    #y
			pushi    0
			lat      temp0
			send     4
code_0859:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {EGO-MOVESPD}
			push    
			pushi    #moveSpeed
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    4
			lofsa    {SIGNAL-BITS}
			push    
			pushi    #signal
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    4
			lofsa    {ILLEGAL-BITS}
			push    
			pushi    #illegalBits
			pushi    0
			lag      ego
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {HOWFAST}
			push    
			lsg      howFast
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {ICONBAR}
			push    
			lag      theIconBar
			bnt      code_08b6
			pushi    #name
			pushi    0
			send     4
code_08b6:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {CUR-ICON}
			push    
			lag      theIconBar
			bnt      code_08db
			pushi    #curIcon
			pushi    0
			send     4
			bnt      code_08db
			pushi    #name
			pushi    0
			pushi    #curIcon
			pushi    0
			lag      theIconBar
			send     4
			send     4
code_08db:
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {DETAIL-LEVEL}
			push    
			pushi    #detailLevel
			pushi    0
			lag      theGame
			send     4
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    2
			lofsa    {CD-AUDIO}
			push    
			lsg      msgType
			ldi      2
			and     
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {VIDEO-DRV}
			push    
			lea      @temp238
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {SOUND-DRV}
			push    
			lea      @temp278
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {AUDIO-DRV}
			push    
			lea      @temp358
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {KEYBOARD-DRV}
			push    
			lea      @temp158
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {JOY-DRV}
			push    
			lea      @temp198
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    1
			lofsa    {MOUSE}
			push    
			lea      @temp318
			push    
			call     localproc_0010,  6
			pushi    3
			dup     
			lofsa    {LARGEST-HEAP}
			push    
			pushi    1
			pushi    0
			callk    MemoryInfo,  2
			push    
			call     localproc_0010,  6
			pushi    3
			dup     
			lofsa    {FREE-HEAP}
			push    
			pushi    1
			pushi    1
			callk    MemoryInfo,  2
			push    
			call     localproc_0010,  6
			pushi    3
			dup     
			lofsa    {TOTAL-HUNK}
			push    
			pushi    1
			pushi    4
			callk    MemoryInfo,  2
			push    
			ldi      6
			shr     
			push    
			call     localproc_0010,  6
			pushi    3
			dup     
			lofsa    {LARGEST-HUNK}
			push    
			pushi    1
			pushi    2
			callk    MemoryInfo,  2
			push    
			call     localproc_0010,  6
			pushi    3
			dup     
			lofsa    {FREE-HUNK}
			push    
			pushi    1
			pushi    3
			callk    MemoryInfo,  2
			push    
			ldi      6
			shr     
			push    
			call     localproc_0010,  6
			pushi    3
			pushi    6
			lsl      logHandle
			lofsa    {**********************************\0D\n}
			push    
			callk    FileIO,  6
			pushi    2
			pushi    1
			lsl      logHandle
			callk    FileIO,  4
code_09d8:
			pushi    3
			lea      @temp78
			push    
			lofsa    {%s.mem}
			push    
			lea      @sysLogPath
			push    
			callk    Format,  6
			pushi    65535
			pushi    3
			pushi    0
			lea      @temp78
			push    
			pushi    2
			callk    FileIO,  6
			sal      logHandle
			eq?     
			bnt      code_0a29
			pushi    65535
			pushi    3
			pushi    0
			lea      @temp78
			push    
			pushi    0
			callk    FileIO,  6
			sal      logHandle
			eq?     
			bnt      code_0a29
			pushi    #font
			pushi    1
			pushi    999
			pushi    206
			pushi    2
			lofsa    {Error: Couldn't open memory file %s!}
			push    
			lea      @temp78
			push    
			pushi    110
			pushi    0
			class    Print
			send     18
			jmp      code_0a64
code_0a29:
			pushi    3
			pushi    6
			lsl      logHandle
			lea      @temp138
			push    
			callk    FileIO,  6
			pushi    3
			pushi    6
			lsl      logHandle
			lofsa    {\n}
			push    
			callk    FileIO,  6
			pushi    3
			pushi    6
			lsl      logHandle
			lea      @temp48
			push    
			callk    FileIO,  6
			pushi    3
			pushi    6
			lsl      logHandle
			lofsa    {\n}
			push    
			callk    FileIO,  6
			pushi    2
			pushi    1
			lsl      logHandle
			callk    FileIO,  4
code_0a64:
			lat      temp7
			sag      inputFont
			pushi    1
			pushi    952
			callk    DisposeScript,  2
			ret     
		)
	)
)
