;;; Sierra Script 1.0 - (do not remove this comment)
(script# 0)
(include game.sh)
(use DemoWin)
(use Print)
(use Ego)
(use Sound)
(use Game)
(use User)
(use System)

(public
	Demo 0
)

(local
	ego
	theGame
	curRoom
	unused_1
	quit
	cast
	regions
	timers
	sounds
	inventory
	addToPics
	curRoomNum
	prevRoomNum
	newRoomNum
	debugOn
	score
	possibleScore
	textCode
	cuees
	theCursor
	normalCursor =  ARROW_CURSOR
	waitCursor =  HAND_CURSOR
	userFont =  USERFONT
	smallFont =  4
	lastEvent
	modelessDialog
	bigFont =  USERFONT
	version
	unused_3
	curSaveDir
	unused_4
	perspective
	features
	unused_5
	useSortedFeatures
	unused_6
	overlays =  -1
	doMotionCue
	systemWindow
	unused_7
	unused_8
	modelessPort
	sysLogPath
	global43
	global44
	global45
	global46
	global47
	global48
	global49
	global50
	global51
	global52
	global53
	global54
	global55
	global56
	global57
	global58
	global59
	global60
	global61
	endSysLogPath
	gameControls
	ftrInitializer
	doVerbCode
	approachCode
	useObstacles =  TRUE
	unused_9
	theIconBar
	mouseX
	mouseY
	keyDownHandler
	mouseDownHandler
	directionHandler
	speechHandler
	lastVolume
	pMouse
	theDoits
	eatMice =  60
	user
	syncBias
	theSync
	unused_10
	fastCast
	inputFont
	tickOffset
	howFast
	gameTime
	narrator
	msgType =  1
	messager
	prints
	walkHandler
	textSpeed =  2
	altPolyList
	global96
	global97
	global98
	lastSysGlobal
	global100
	global101
	global102
	debugging
	global104
	SFX
	music
	ambience
)
(class Demo of Game
	(properties
		script 0
		printLang ENGLISH
		_detailLevel 3
		panelObj 0
		panelSelector 0
		handsOffCode 0
		handsOnCode 0
	)
	
	(method (init)
		(= user User)
		(= ego demoEgo)
		(if
		(and (FileIO fileExists {selector}) (FileIO fileExists {c}))
			(= debugging TRUE)
		)
		(= userFont USERFONT)
		(user alterEgo: ego)
		(super init:)
		(= music musicSound)
		(= ambience theGlobalSound)
		(= SFX soundEffects)
		(music owner: self flags: 1 init:)
		(ambience owner: self flags: 1 init:)
		(SFX owner: self flags: 1 init:)
		(= systemWindow DemoWin)
		(= inventory NULL)
		(= waitCursor theWaitCursor)
		(keyDownHandler addToFront: self)
		(mouseDownHandler addToFront: self)
		(DisposeScript INVENT)
		(self
			setCursor: (theWaitCursor posn: 300 180 yourself:)
			handsOff:
			newRoom: 100
		)
	)
	
	(method (handleEvent event &tmp temp0)
		(= temp0 0)
		(curRoom handleEvent: event)
		(if
			(or
				(== (event type?) keyDown)
				(== (event type?) mouseDown)
			)
			(if modelessDialog (= temp0 1))
			(if modelessDialog (modelessDialog dispose:))
			(if
				(or
					(== (event type?) mouseDown)
					(== (event message?) SPACEBAR)
					(== (event message?) ENTER)
				)
				(if (and temp0 (curRoom script?))
					((curRoom script?) seconds: 0)
					((curRoom script?) cycles: 1)
					(event claimed: TRUE)
				)
			else
				(= quit
					(Print
						addText: {Would you like to quit the INN demo?}
						addButton: TRUE { Yes_} 80 20
						addButton: FALSE { No_} 120 20
						init:
					)
				)
				(event claimed: TRUE)
			)
		)
	)
	
	(method (setCursor cursorNumber param2 param3 param4 &tmp theTheCursor temp1 temp2)
		(= theTheCursor theCursor)
		(= theCursor cursorNumber)
		(if (> argc 2)
			(= temp1 (if (< param3 0) 0 else param3))
			(= temp2 (if (< param4 0) 0 else param4))
			(SetCursor temp1 temp2)
		)
		(if (IsObject cursorNumber)
			(if argc ((= theCursor cursorNumber) init:))
			(cursorNumber init:)
		else
			(SetCursor cursorNumber 0 0)
		)
		(return theTheCursor)
	)
	
	(method (handsOff)
		(user canInput: TRUE canControl: FALSE)
		(self setCursor: waitCursor TRUE)
	)
	
	(method (handsOn)
		(user canInput: TRUE canControl: TRUE)
		(self setCursor: normalCursor TRUE)
	)
)

(instance demoEgo of Ego
	(properties
		view 0
	)
)

(instance theWaitCursor of Cursor
	(properties
		view 996
	)
)

(instance theGlobalSound of Sound
	(properties)
)

(instance musicSound of Sound
	(properties)
)

(instance soundEffects of Sound
	(properties)
)
