;;; Sierra Script 1.0 - (do not remove this comment)
(script# 200)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	bridge 0
)

(instance bridge of InnRoom
	(properties
		picture 200
		nextRoom 220
		prevRoom 140
	)
	
	(method (init)
		(otherCards init:)
		(myCard init:)
		(super init: &rest)
		(self setScript: sBridge)
	)
)

(instance sBridge of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{Tournament bridge with partners and opponents ranging
						from amateurs to the highest caliber players in the country.}
					modeless: 1
					init:
				)
				(= seconds 8)
			)
			(2
				(if modelessDialog (modelessDialog dispose:))
				(SFX number: 100 play:)
				(myCard
					illegalBits: 0
					ignoreActors: 1
					setMotion: MoveTo 163 106 self
				)
			)
			(3 (= seconds 2))
			(4
				(myCard dispose:)
				(SFX number: 501 play:)
				(otherCards
					setLoop: 1
					cel: 0
					setCycle: Forward
					setMotion: MoveTo 0 96 self
				)
			)
			(5
				(otherCards dispose:)
				(= seconds 4)
			)
			(6
				(if modelessDialog (modelessDialog dispose:))
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance otherCards of Actor
	(properties
		x 163
		y 106
		view 200
		loop 2
		moveSpeed 1
	)
)

(instance myCard of Actor
	(properties
		x 147
		y 166
		view 200
		moveSpeed 1
	)
)
