;;; Sierra Script 1.0 - (do not remove this comment)
(script# 130)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	redBaron 0
)

(local
	local0
)
(instance redBaron of InnRoom
	(properties
		picture 130
		style FADEOUT
		nextRoom 170
		prevRoom 120
	)
	
	(method (init)
		(dial init:)
		(movingPeg init: cycleSpeed: 20 setCycle: Forward)
		(comp init: cycleSpeed: 30 setCycle: Forward)
		(super init: &rest)
		(self setScript: sRedBaron)
	)
)

(instance sRedBaron of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{Imagine sitting in your family room, engaging in an aerial dogfight
						or a chess game with someone 2,000 miles away.}
					modeless: 1
					init:
				)
				(= seconds 9)
			)
			(2
				(if modelessDialog (modelessDialog dispose:))
				(gun1 init: cel: (gun1 lastCel:))
				(gun2 init: cel: (gun2 lastCel:))
				(dial cycleSpeed: 35 setCycle: Forward)
				(music number: 3001 play:)
				(plane2 init: cycleSpeed: 7 setCycle: EndLoop self)
				(self setScript: fireScript)
			)
			(3
				(plane2 setLoop: 1 cel: 0 setCycle: EndLoop self)
			)
			(4
				(plane2 dispose:)
				(music number: 3001 play:)
				(plane1 init: cycleSpeed: 5 setCycle: EndLoop self)
			)
			(5
				(plane1 dispose:)
				(music number: 3001 play:)
				(plane3 init: cycleSpeed: 5 setCycle: EndLoop self)
			)
			(6
				(plane3 dispose:)
				(script dispose:)
				(gun1 dispose:)
				(gun2 dispose:)
				(= seconds 3)
			)
			(7 (= seconds 2))
			(8
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance fireScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(SFX number: 3002 play:)
				(gun1 cel: 0 setCycle: EndLoop self)
			)
			(1
				(SFX number: 3002 play:)
				(gun2 cel: 0 setCycle: EndLoop self)
			)
			(2
				(if (== (++ local0) 8)
					(self dispose:)
				else
					(self init:)
				)
			)
		)
	)
)

(instance movingPeg of Actor
	(properties
		x 159
		y 189
		view 502
		cel 1
	)
)

(instance comp of Actor
	(properties
		x 262
		y 184
		view 502
		loop 1
		cel 3
		cycleSpeed 7
	)
)

(instance dial of Actor
	(properties
		x 161
		y 146
		view 502
		loop 2
		cycleSpeed 8
	)
)

(instance gun1 of Actor
	(properties
		x 98
		y 100
		view 503
	)
)

(instance gun2 of Actor
	(properties
		x 193
		y 101
		view 503
		loop 1
	)
)

(instance plane1 of Actor
	(properties
		x 216
		y 88
		view 501
		loop 2
	)
)

(instance plane2 of Actor
	(properties
		x 141
		y 38
		view 501
	)
)

(instance plane3 of Actor
	(properties
		x 49
		y 89
		view 501
		loop 3
	)
)
