;;; Sierra Script 1.0 - (do not remove this comment)
(script# 230)
(include game.sh)
(use Main)
(use DoDisplay)
(use InnRoom)
(use File)
(use System)

(public
	title2 0
)

(local
	retailTextFileExists
)
(instance title2 of InnRoom
	(properties
		picture 100
		prevRoom 190
	)
	
	(method (init)
		(super init: &rest)
		(self setScript: sTitle)
	)
)

(instance sTitle of Script
	(properties)
	
	(method (changeState newState &tmp [str 300])
		(switch (= state newState)
			(0
				(= retailTextFileExists (FileIO fileExists {retail}))
				(= seconds 2)
			)
			(1
				(Display 230 0 p_font 800 p_at 95 10 p_color 223)
				(Display 230 0 p_font 800 p_at 93 7 p_color 165)
				(if retailTextFileExists
					(= cycles 1)
				else
					(Display 230 1 p_font 800 p_at 103 34 p_color 223)
					(Display 230 1 p_font 800 p_at 101 30 p_color 165)
					(= seconds 3)
				)
			)
			(2
				(if retailTextFileExists
					(retail_txt open: 1 read: @str 300)
					(DoDisplay
						setColor: 165 223
						font: 800
						posn: 10 125
						addText: @str
					)
				else
					(DoDisplay
						setColor: 165 223
						font: 800
						posn: 10 120
						addText:
							{Call for a FREE* MEMBERSHIP KIT plus 5 FREE Hours
							to try all the fun and games of ImagiNation!\n\n\n\n
							*$5.95 Shipping and Handling}
					)
				)
				(= seconds 15)
			)
			(3
				(DoDisplay restore:)
				(theGame restart:)
			)
		)
	)
)

(instance retail_txt of File
	(properties
		name "retail.txt"
	)
)
