;;; Sierra Script 1.0 - (do not remove this comment)
(script# 2)
(include game.sh)
(use Main)
(use System)


(class DoDisplay of Object
	(properties
		saveBits 0
		saveBits2 0
		x -1
		y -1
		front -1
		back -1
		width 300
		font 0
	)
	
	(method (restore)
		(= width 300)
		(Display {} p_restore saveBits2)
		(Display {} p_restore saveBits)
	)
	
	(method (posn theX theY)
		(= x theX)
		(= y theY)
	)
	
	(method (setColor theFront theBack)
		(= front theFront)
		(= back theBack)
	)
	
	(method (addText param1 &tmp theX theY)
		(if (not font) (= font userFont))
		(if (or saveBits saveBits2) (self restore:))
		(= theX x)
		(= theY y)
		(if (not (== back -1))
			(= saveBits
				(Display param1
					p_at (+ theX 1) theY
					p_font font
					p_width width
					p_color back
					p_save
				)
			)
		)
		(= saveBits2
			(Display param1
				p_at theX theY
				p_font font
				p_width width
				p_color front
				p_save
			)
		)
		(= font SYSFONT)
	)
)
