;;; Sierra Script 1.0 - (do not remove this comment)
(script# 990)
(include game.sh)
(use Main)
(use Intrface)
(use Print)
(use Dialog)
(use File)
(use System)

(public
	GetDirectory 0
)

(local
	default
	i
	numGames
	selected
	theStatus
	[butBuf1 15]
	[butBuf2 15]
	[butBuf3 15]
	[butBuf4 15]
	[theText 25]
)
(procedure (GetDirectory param1 &tmp temp0 [temp1 40] [temp41 100] [temp141 50] temp191)
	(asm
code_094c:
		pushi    2
		pushi    29
		pushi    1
		lsp      param1
		callk    StrLen,  2
		push    
		ldi      6
		add     
		push    
		calle    Max,  4
		push    
		ldi      11
		add     
		sat      temp191
		pushi    #font
		pushi    1
		pushi    0
		pushi    205
		pushi    7
		pushi    1
		pushi    0
		pushi    0
		pushi    1
		pushi    0
		pushi    0
		pushi    990
		pushi    207
		pushi    5
		pushi    2
		lea      @temp1
		push    
		lsp      param1
		callk    StrCpy,  4
		push    
		lst      temp191
		pushi    0
		pushi    20
		lsp      param1
		pushi    212
		pushi    8
		pushi    1
		pushi    27
		pushi    0
		pushi    0
		pushi    1
		pushi    0
		pushi    34
		pushi    990
		pushi    212
		pushi    8
		pushi    0
		pushi    38
		pushi    0
		pushi    0
		pushi    1
		pushi    50
		pushi    34
		pushi    990
		pushi    110
		pushi    0
		pushi    #new
		pushi    0
		class    Print
		send     4
		send     82
		sat      temp0
		not     
		bnt      code_09c6
		ldi      0
		ret     
code_09c6:
		pushi    1
		lea      @temp1
		push    
		callk    StrLen,  2
		not     
		bnt      code_09d9
		pushi    1
		lea      @temp1
		push    
		callk    GetCWD,  2
code_09d9:
		pushi    1
		lea      @temp1
		push    
		callk    ValidPath,  2
		bnt      code_09f3
		pushi    2
		lsp      param1
		lea      @temp1
		push    
		callk    StrCpy,  4
		ldi      1
		ret     
		jmp      code_094c
code_09f3:
		pushi    7
		pushi    0
		pushi    990
		pushi    29
		pushi    0
		pushi    0
		pushi    1
		lea      @temp141
		push    
		callk    Message,  14
		pushi    3
		lea      @temp41
		push    
		lea      @temp141
		push    
		lea      @temp1
		push    
		callk    Format,  6
		pushi    #font
		pushi    1
		pushi    0
		pushi    205
		pushi    1
		lea      @temp41
		push    
		pushi    110
		pushi    0
		pushi    #new
		pushi    0
		class    Print
		send     4
		send     16
		jmp      code_094c
		ret     
	)
)

(procedure (GetStatus)
	(return
		(cond 
			((== self Restore) 0)
			((HaveSpace) 1)
			(numGames 2)
			(else 3)
		)
	)
)

(procedure (HaveSpace)
	(if (< numGames 20) (CheckFreeSpace curSaveDir))
)

(procedure (NeedDescription)
	((Print new:) font: 0 addText: 3 0 0 1 0 0 990 init:)
)

(class SRDialog of Dialog
	(properties
		elements 0
		size 0
		text 0
		font 0
		window 0
		theItem 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		time 0
		caller 0
		seconds 0
		lastSeconds 0
		eatTheMice 0
		lastTicks 0
	)
	
	(method (init param1 param2 param3 &tmp [temp0 250])
		(= window systemWindow)
		(= nsBottom 0)
		(if
			(==
				(= numGames
					(GetSaveFiles (theGame name?) param2 param3)
				)
				-1
			)
			(return 0)
		)
		(if (== (= theStatus (GetStatus)) 1)
			(editI
				text: (StrCpy param1 param2)
				font: smallFont
				setSize:
				moveTo: 4 4
			)
			(self add: editI setSize:)
		)
		(selectorI
			text: param2
			font: smallFont
			setSize:
			moveTo: 4 (+ nsBottom 4)
			state: 2
		)
		(switch theStatus
			(0
				(Message msgGET 990 26 0 0 1 @butBuf1)
			)
			(1
				(Message msgGET 990 28 0 0 1 @butBuf1)
			)
			(else 
				(Message msgGET 990 25 0 0 1 @butBuf1)
			)
		)
		(= i (+ (selectorI nsRight?) 4))
		(okI
			text: @butBuf1
			setSize:
			moveTo: i (selectorI nsTop?)
			state:
				(if
					(or
						(and (== theStatus 0) (not numGames))
						(== theStatus 3)
					)
					0
				else
					3
				)
		)
		(Message msgGET 990 24 0 0 1 @butBuf2)
		(deleteI
			text: @butBuf2
			setSize:
			moveTo: i (+ (okI nsBottom?) 4)
			state: (if (not numGames) 0 else 3)
		)
		(Message msgGET 990 23 0 0 1 @butBuf3)
		(changeDirI
			text: @butBuf3
			setSize:
			moveTo: i (+ (deleteI nsBottom?) 4)
			state: (& (changeDirI state?) $fff7)
		)
		(Message msgGET 990 22 0 0 1 @butBuf4)
		(cancelI
			text: @butBuf4
			setSize:
			moveTo: i (+ (changeDirI nsBottom?) 4)
			state: (& (cancelI state?) $fff7)
		)
		(self
			add: selectorI okI deleteI changeDirI cancelI
			setSize:
		)
		(switch theStatus
			(0
				(Message msgGET 990 10 0 0 1 @temp0)
			)
			(1
				(Message msgGET 990 11 0 0 1 @temp0)
			)
			(else 
				(Message msgGET 990 30 0 0 1 @temp0)
			)
		)
		(textI
			text: @temp0
			setSize: (- (- nsRight nsLeft) 8)
			moveTo: 4 4
		)
		(= i (+ (textI nsBottom?) 4))
		(self eachElementDo: #move 0 i)
		(self add: textI setSize: center: open: 4 -1)
		(return 1)
	)
	
	(method (doit param1 &tmp temp0 temp1 temp2 [temp3 361] [temp364 21] [temp385 140])
		(asm
			pushSelf
			class    Restore
			eq?     
			bnt      code_03eb
			lap      argc
			bnt      code_03eb
			lap      param1
			bnt      code_03eb
			pushi    2
			pushi    0
			pushi    3
			lea      @temp385
			push    
			lofsa    {%ssg.dir}
			push    
			pushi    #name
			pushi    0
			lag      theGame
			send     4
			push    
			callk    Format,  6
			push    
			callk    FileIO,  4
			sat      temp0
			push    
			ldi      65535
			eq?     
			bnt      code_03e4
			ret     
code_03e4:
			pushi    2
			pushi    1
			lst      temp0
			callk    FileIO,  4
code_03eb:
			pushi    #init
			pushi    3
			lsp      param1
			lea      @temp3
			push    
			lea      @temp364
			push    
			self     10
			not     
			bnt      code_0403
			ldi      65535
			ret     
code_0403:
			lsl      theStatus
			dup     
			ldi      0
			eq?     
			bnt      code_0419
			lal      numGames
			bnt      code_0414
			lofsa    okI
			jmp      code_0432
code_0414:
			lofsa    changeDirI
			jmp      code_0432
code_0419:
			dup     
			ldi      1
			eq?     
			bnt      code_0424
			lofsa    editI
			jmp      code_0432
code_0424:
			dup     
			ldi      2
			eq?     
			bnt      code_042f
			lofsa    okI
			jmp      code_0432
code_042f:
			lofsa    changeDirI
code_0432:
			toss    
			sal      default
			pushi    #doit
			pushi    1
			push    
			super    Dialog,  6
			sal      i
			pushi    #indexOf
			pushi    1
			pushi    #cursor
			pushi    0
			lofsa    selectorI
			send     4
			push    
			lofsa    selectorI
			send     6
			sal      selected
			push    
			ldi      18
			mul     
			sat      temp2
			lsl      i
			lofsa    changeDirI
			eq?     
			bnt      code_04a9
			pushi    #dispose
			pushi    0
			self     4
			pushi    1
			lsg      curSaveDir
			call     GetDirectory,  2
			bnt      code_0494
			pushi    3
			pushi    #name
			pushi    0
			lag      theGame
			send     4
			push    
			lea      @temp3
			push    
			lea      @temp364
			push    
			callk    GetSaveFiles,  6
			sal      numGames
			push    
			ldi      65535
			eq?     
			bnt      code_0494
			ldi      65535
			sat      temp1
			jmp      code_0732
code_0494:
			pushi    #init
			pushi    3
			lsp      param1
			lea      @temp3
			push    
			lea      @temp364
			push    
			self     10
			jmp      code_0403
code_04a9:
			lsl      theStatus
			ldi      2
			eq?     
			bnt      code_04f3
			lsl      i
			lofsa    okI
			eq?     
			bnt      code_04f3
			pushi    #dispose
			pushi    0
			self     4
			pushi    #doit
			pushi    1
			pushi    2
			lsp      param1
			lat      temp2
			leai     @temp3
			push    
			callk    StrCpy,  4
			push    
			lofsa    GetReplaceName
			send     6
			bnt      code_04de
			lal      selected
			lati     temp364
			sat      temp1
			jmp      code_0732
code_04de:
			pushi    #init
			pushi    3
			lsp      param1
			lea      @temp3
			push    
			lea      @temp364
			push    
			self     10
			jmp      code_0403
code_04f3:
			lsl      theStatus
			ldi      1
			eq?     
			bnt      code_05b4
			lsl      i
			lofsa    okI
			eq?     
			bt       code_050c
			lsl      i
			lofsa    editI
			eq?     
			bnt      code_05b4
code_050c:
			pushi    1
			lsp      param1
			callk    StrLen,  2
			push    
			ldi      0
			eq?     
			bnt      code_0537
			pushi    #dispose
			pushi    0
			self     4
			pushi    0
			call     NeedDescription,  0
			pushi    #init
			pushi    3
			lsp      param1
			lea      @temp3
			push    
			lea      @temp364
			push    
			self     10
			jmp      code_0403
code_0537:
			ldi      65535
			sat      temp1
			ldi      0
			sal      i
code_053f:
			lsl      i
			lal      numGames
			lt?     
			bnt      code_055e
			pushi    2
			lsp      param1
			lsl      i
			ldi      18
			mul     
			leai     @temp3
			push    
			callk    StrCmp,  4
			sat      temp1
			not     
			bnt      code_055a
code_055a:
			+al      i
			jmp      code_053f
code_055e:
			lat      temp1
			not     
			bnt      code_056d
			lal      i
			lati     temp364
			sat      temp1
			jmp      code_0732
code_056d:
			lsl      numGames
			ldi      20
			eq?     
			bnt      code_057e
			lal      selected
			lati     temp364
			sat      temp1
			jmp      code_0732
code_057e:
			ldi      0
			sat      temp1
code_0582:
			ldi      1
			bnt      code_0732
			ldi      0
			sal      i
code_058b:
			lsl      i
			lal      numGames
			lt?     
			bnt      code_05a0
			lst      temp1
			lal      i
			lati     temp364
			eq?     
			bnt      code_059c
code_059c:
			+al      i
			jmp      code_058b
code_05a0:
			lsl      i
			lal      numGames
			eq?     
			bnt      code_05aa
			jmp      code_0732
code_05aa:
			+at      temp1
			jmp      code_0582
			jmp      code_0732
			jmp      code_0403
code_05b4:
			lsl      i
			lofsa    deleteI
			eq?     
			bnt      code_06de
			pushi    #dispose
			pushi    0
			self     4
			pushi    #addText
			pushi    7
			pushi    12
			pushi    0
			pushi    0
			pushi    1
			pushi    0
			pushi    0
			pushi    990
			pushi    212
			pushi    8
			pushi    0
			pushi    31
			pushi    0
			pushi    0
			pushi    1
			pushi    0
			pushi    35
			pushi    990
			pushi    212
			pushi    8
			pushi    1
			pushi    32
			pushi    0
			pushi    0
			pushi    1
			pushi    50
			pushi    35
			pushi    990
			pushi    110
			pushi    0
			pushi    #new
			pushi    0
			class    Print
			send     4
			send     62
			not     
			bnt      code_0618
			pushi    #init
			pushi    3
			lsp      param1
			lea      @temp3
			push    
			lea      @temp364
			push    
			self     10
			jmp      code_0403
code_0618:
			pushi    #name
			pushi    1
			pushi    3
			pushi    7
			lea      @temp385
			push    
			pushi    #name
			pushi    0
			lag      theGame
			send     4
			push    
			callk    DeviceInfo,  6
			push    
			pushi    196
			pushi    1
			pushi    2
			pushi    #new
			pushi    0
			class    File
			send     4
			sat      temp0
			send     12
			ldi      2570
			sat      temp1
			ldi      0
			sal      i
code_064a:
			lsl      i
			lal      numGames
			lt?     
			bnt      code_068b
			lsl      i
			lal      selected
			ne?     
			bnt      code_0687
			pushi    #write
			pushi    2
			lal      i
			leai     @temp364
			push    
			pushi    2
			lat      temp0
			send     8
			pushi    338
			pushi    #x
			lsl      i
			ldi      18
			mul     
			leai     @temp3
			push    
			lat      temp0
			send     6
			pushi    #write
			pushi    2
			lea      @temp1
			push    
			pushi    1
			lat      temp0
			send     8
code_0687:
			+al      i
			jmp      code_064a
code_068b:
			ldi      65535
			sat      temp1
			pushi    #write
			pushi    2
			lea      @temp1
			push    
			pushi    2
			pushi    342
			pushi    0
			pushi    111
			pushi    0
			lat      temp0
			send     16
			pushi    4
			pushi    8
			lea      @temp385
			push    
			pushi    #name
			pushi    0
			lag      theGame
			send     4
			push    
			lal      selected
			lsti     temp364
			callk    DeviceInfo,  8
			pushi    2
			pushi    4
			lea      @temp385
			push    
			callk    FileIO,  4
			pushi    #init
			pushi    3
			lsp      param1
			lea      @temp3
			push    
			lea      @temp364
			push    
			self     10
			jmp      code_0403
code_06de:
			lsl      i
			lofsa    okI
			eq?     
			bnt      code_06f2
			lal      selected
			lati     temp364
			sat      temp1
			jmp      code_0732
			jmp      code_0403
code_06f2:
			lsl      i
			ldi      65535
			eq?     
			bt       code_0701
			lsl      i
			lofsa    cancelI
			eq?     
			bnt      code_070a
code_0701:
			ldi      65535
			sat      temp1
			jmp      code_0732
			jmp      code_0403
code_070a:
			lsl      theStatus
			ldi      1
			eq?     
			bnt      code_0403
			pushi    #cursor
			pushi    1
			pushi    1
			pushi    2
			lsp      param1
			lat      temp2
			leai     @temp3
			push    
			callk    StrCpy,  4
			push    
			callk    StrLen,  2
			push    
			pushi    80
			pushi    0
			lofsa    editI
			send     10
			jmp      code_0403
code_0732:
			pushi    1
			pushi    993
			callk    DisposeScript,  2
			pushi    #dispose
			pushi    0
			self     4
			pushi    1
			pushi    990
			callk    DisposeScript,  2
			lat      temp1
			ret     
		)
	)
	
	(method (dispose)
		(super dispose: &rest)
	)
)

(class Restore of SRDialog
	(properties
		elements 0
		size 0
		text 0
		font 0
		window 0
		theItem 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		time 0
		caller 0
		seconds 0
		lastSeconds 0
		eatTheMice 0
		lastTicks 0
	)
	
	(method (init)
		(Message msgGET 990 20 0 0 1 @theText)
		(= text @theText)
		(super init: &rest)
	)
)

(class Save of SRDialog
	(properties
		elements 0
		size 0
		text 0
		font 0
		window 0
		theItem 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		time 0
		caller 0
		seconds 0
		lastSeconds 0
		eatTheMice 0
		lastTicks 0
	)
	
	(method (init)
		(Message msgGET 990 21 0 0 1 @theText)
		(= text @theText)
		(super init: &rest)
	)
)

(instance GetReplaceName of Dialog
	(properties)
	
	(method (doit param1 &tmp temp0 [temp1 15] [temp16 15] [temp31 15] [temp46 15])
		(= window systemWindow)
		(Message msgGET 990 33 0 0 1 @temp1)
		(text1 text: @temp1 setSize: moveTo: 4 4)
		(self add: text1 setSize:)
		(oldName
			text: param1
			font: smallFont
			setSize:
			moveTo: 4 nsBottom
		)
		(self add: oldName setSize:)
		(Message msgGET 990 34 0 0 1 @temp16)
		(text2 text: @temp16 setSize: moveTo: 4 nsBottom)
		(self add: text2 setSize:)
		(newName
			text: param1
			font: smallFont
			setSize:
			moveTo: 4 nsBottom
		)
		(self add: newName setSize:)
		(Message msgGET 990 33 0 0 1 @temp31)
		(button1 text: @temp31 nsLeft: 0 nsTop: 0 setSize:)
		(Message msgGET 990 38 0 0 1 @temp46)
		(button2 text: @temp46 nsLeft: 0 nsTop: 0 setSize:)
		(button2
			moveTo: (- nsRight (+ (button2 nsRight?) 4)) nsBottom
		)
		(button1
			moveTo: (- (button2 nsLeft?) (+ (button1 nsRight?) 4)) nsBottom
		)
		(self add: button1 button2 setSize: center: open: 0 -1)
		(= temp0 (super doit: newName))
		(self dispose:)
		(if (not (StrLen param1))
			(NeedDescription)
			(= temp0 0)
		)
		(return (if (== temp0 newName) else (== temp0 button1)))
	)
)

(instance selectorI of DSelector
	(properties
		x 36
		y 8
	)
)

(instance editI of DEdit
	(properties
		max 35
	)
)

(instance okI of DButton
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance cancelI of DButton
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance changeDirI of DButton
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance deleteI of DButton
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance textI of DText
	(properties
		font 0
	)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance text1 of DText
	(properties
		font 0
	)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance text2 of DText
	(properties
		font 0
	)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance oldName of DText
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance newName of DEdit
	(properties
		max 35
	)
)

(instance button1 of DButton
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)

(instance button2 of DButton
	(properties)
	
	(method (dispose)
		(super dispose: 1)
	)
)
