;;; Sierra Script 1.0 - (do not remove this comment)
(script# 948)
(include game.sh)
(use Main)
(use Intrface)
(use Print)
(use Dialog)
(use Feature)
(use Window)
(use File)
(use Actor)
(use System)


(local
	[nameString 50]
	[nounStr 30]
	[vDoStr 100]
	[vLookStr 100]
	[vTalkStr 100]
	walkString =  { WALK____________}
	[verbString 6] = [{ LOOK____________} { DO______________} { TALK____________} { ASK_____________} { HELP____________} {}]
	toScreen
	drawNSRect =  1
	inited
	theType
	hasDoVerb
	oldWindow
	file
)
(procedure (localproc_0286 param1)
	(param1 sightAngle: (GetNumber {sight angle?} 40))
)

(procedure (localproc_029b param1 &tmp newEvent temp1 temp2 newEventY newEventX newEventY_2 newEventX_2)
	(Prints {Click left mouse button on top left corner})
	(while (!= ((= newEvent (Event new:)) type?) 1)
		(newEvent dispose:)
	)
	(GlobalToLocal newEvent)
	(= newEventY (newEvent y?))
	(= newEventX (newEvent x?))
	(newEvent dispose:)
	(Prints {Click left mouse button on bottom right corner})
	(while (!= ((= newEvent (Event new:)) type?) 1)
		(newEvent dispose:)
	)
	(GlobalToLocal newEvent)
	(= newEventY_2 (newEvent y?))
	(= newEventX_2 (newEvent x?))
	(newEvent dispose:)
	(= temp1 (+ (/ (- newEventX_2 newEventX) 2) newEventX))
	(= temp2 (+ (/ (- newEventY_2 newEventY) 2) newEventY))
	(param1
		x: temp1
		y: temp2
		nsLeft: newEventX
		nsTop: newEventY
		nsBottom: newEventY_2
		nsRight: newEventX_2
	)
	(if drawNSRect
		(Graph GDrawLine
			newEventY
			newEventX
			newEventY
			newEventX_2
			1
			0
		)
		(Graph GDrawLine
			newEventY_2
			newEventX
			newEventY_2
			newEventX_2
			1
			0
		)
		(Graph GDrawLine
			newEventY
			newEventX
			newEventY_2
			newEventX
			1
			0
		)
		(Graph GDrawLine
			newEventY
			newEventX_2
			newEventY_2
			newEventX_2
			1
			0
		)
		(Graph GShowBits
			newEventY
			newEventX
			(+ newEventY_2 1)
			(+ newEventX_2 1)
			1
		)
	)
)

(procedure (localproc_03c6 param1 &tmp newEvent)
	(param1
		view: (GetNumber {View?} (curRoom curPic?))
		loop: (GetNumber {Loop?} 0)
		cel: (GetNumber {Cel?} 0)
		signal: 16400
		priority: 15
		init:
	)
	(if (param1 respondsTo: #illegalBits)
		(param1 illegalBits: 0)
	)
	(while (!= ((= newEvent (Event new:)) type?) 1)
		(GlobalToLocal newEvent)
		(param1 posn: (newEvent x?) (newEvent y?))
		(Animate (cast elements?) 0)
		(newEvent dispose:)
	)
	(newEvent dispose:)
)

(procedure (localproc_046c param1 &tmp newEvent newEventX newEventY [temp3 10] temp13)
	(if
		(Print
			addText: {Where should the approach point be?}
			addButton: 1 {Select with mouse} 0 20
			addButton: 0 {Default to x, y} 0 34
			init:
		)
		(while (!= ((= newEvent (Event new:)) type?) 1)
			(newEvent dispose:)
		)
		(GlobalToLocal newEvent)
		(param1
			approachX: (= newEventX (newEvent x?))
			approachY: (= newEventY (newEvent y?))
		)
		(newEvent dispose:)
		(Graph GDrawLine
			(- newEventY 1)
			(- newEventX 1)
			(- newEventY 1)
			(+ newEventX 1)
			7
		)
		(Graph GDrawLine
			newEventY
			(- newEventX 1)
			newEventY
			(+ newEventX 1)
			7
		)
		(Graph GDrawLine
			(+ newEventY 1)
			(- newEventX 1)
			(+ newEventY 1)
			(+ newEventX 1)
			7
		)
		(Graph GDrawLine
			newEventY
			newEventX
			newEventY
			newEventX
			0
		)
		(Graph GShowBits
			(- newEventY 1)
			(- newEventX 1)
			(+ newEventY 2)
			(+ newEventX 2)
			1
		)
	else
		(param1 approachX: (param1 x?) approachY: (param1 y?))
	)
	(= temp3 0)
	(= temp13
		(Print
			addText: {How far away must ego} 0 1
			addText: {be before he tries to approach?} 0 12
			addEdit: @temp3 5 -50 13
			addButton: 1 {Select with mouse} 0 32
			addButton: 0 {Always approach} 0 45
			init:
		)
	)
	(cond 
		(temp3 (param1 approachDist: (ReadNumber @temp3)))
		((not temp13) (param1 approachDist: 0))
		(else
			(while (!= ((= newEvent (Event new:)) type?) 1)
				(newEvent dispose:)
			)
			(GlobalToLocal newEvent)
			(= newEventX (newEvent x?))
			(= newEventY (newEvent y?))
			(param1
				approachDist: (GetDistance
					(param1 x?)
					(param1 y?)
					newEventX
					newEventY
				)
			)
			(newEvent dispose:)
			(Graph GDrawLine
				(- newEventY 1)
				(- newEventX 1)
				(- newEventY 1)
				(+ newEventX 1)
				28
			)
			(Graph GDrawLine
				newEventY
				(- newEventX 1)
				newEventY
				(+ newEventX 1)
				28
			)
			(Graph GDrawLine
				(+ newEventY 1)
				(- newEventX 1)
				(+ newEventY 1)
				(+ newEventX 1)
				28
			)
			(Graph GDrawLine
				newEventY
				newEventX
				newEventY
				newEventX
				52
			)
			(Graph GShowBits
				(- newEventY 1)
				(- newEventX 1)
				(+ newEventY 2)
				(+ newEventX 2)
				1
			)
		)
	)
)

(procedure (localproc_06e6)
	(= hasDoVerb
		(Print
			addText: {doVerb method?}
			addButton: 1 {YES} 0 12
			addButton: 0 {NO} 50 12
			init:
		)
	)
)

(procedure (localproc_0714 param1)
	(file name: @sysLogPath writeString: param1 close:)
)

(class CreateObject
	(properties)
	
	(method (doit &tmp [temp0 15] newTheType newEvent)
		(theGame setCursor: 999)
		(= oldWindow systemWindow)
		(= systemWindow wfWin)
		(if (not inited)
			(= temp0 0)
			(Format @temp0 {%d.fea} (curRoom curPic?))
			(if
			(not (GetInput @temp0 30 {Enter path and filename}))
				(return)
			else
				(Format @sysLogPath @temp0)
				(= drawNSRect
					(Print
						addText: {Outline Features?}
						addTitle: {Feature Write V1.0}
						addButton: 1 {YES} 0 12
						addButton: 0 {NO} 50 12
						init:
					)
				)
				(= toScreen
					(Print
						addText: {Display code to screen? (but not doVerb)}
						addTitle: {Feature Write V1.0}
						addButton: 0 {NO} 0 18
						addButton: 1 {YES} 50 18
						init:
					)
				)
				(= inited 1)
			)
		)
		(if
			(not
				(= theType
					(Print
						addText: {Class?}
						addTitle: {Feature Writer V1.0}
						addButton: Feature {Feature} 0 12
						addButton: View {View} 73 12
						addButton: Prop {Prop} 113 12
						addButton: Actor {Actor} 153 12
						init:
					)
				)
			)
			(return)
		)
		(= newTheType (theType new:))
		(= nameString 0)
		(GetInput @nameString 30 {Name?})
		(= nounStr 0)
		(GetInput @nounStr 16 {Noun?})
		(localproc_0286 newTheType)
		(if (== theType Feature)
			(localproc_029b newTheType)
		else
			(localproc_03c6 newTheType)
		)
		(localproc_046c newTheType)
		(if
			(Print
				addText: {Z property}
				addTitle: {Feature Writer V1.0}
				addButton: 0 {NO} 0 12
				addButton: 1 {YES} 50 12
				init:
			)
			(Print
				addText: {Click mouse on object's projection}
				addText: {onto the ground} 0 12
				init:
			)
			(while (!= ((= newEvent (Event new:)) type?) 1)
				(newEvent dispose:)
			)
			(GlobalToLocal newEvent)
			(newTheType z: (- (newEvent y?) (newTheType y?)))
			(newTheType y: (newEvent y?))
			(newEvent dispose:)
		)
		(localproc_06e6)
		(WriteCode doit: newTheType)
		(= systemWindow oldWindow)
	)
)

(class WriteCode
	(properties)
	
	(method (doit param1 &tmp [temp0 400] [temp400 40] [temp440 50] temp490 temp491 [temp492 60] [temp552 40] [temp592 12] temp604 temp605 temp606 [temp607 20] newFeature temp628)
		(if (FileIO fileExists @sysLogPath)
			(Format
				@temp492
				{The file '%s' already exists}
				@sysLogPath
			)
			(if
				(not
					(= temp491
						(Print
							addText: @temp492
							addButton: 1 {Replace} 0 20
							addButton: 2 {Append} 73 20
							addButton: 0 {Cancel} 133 20
							init:
						)
					)
				)
				(return 0)
			)
		)
		(= temp490 (if (== temp491 1) 2 else 0))
		(if
			(not
				((= file (File new:)) name: @sysLogPath open: temp490)
			)
			(Format @temp0 {Error opening '%s'} @sysLogPath)
			(Prints @temp0)
			(file dispose:)
			(return 0)
		)
		(= temp0 0)
		(if (param1 isMemberOf: Feature)
			(Format
				@temp400
				{ \t\tnsLeft\t\t\t%d\0D\n\t\tnsTop\t\t\t\t%d\0D\n\t\tnsBottom\t\t\t%d\0D\n\t\tnsRight\t\t\t%d\0D\n}
				(param1 nsLeft?)
				(param1 nsTop?)
				(param1 nsBottom?)
				(param1 nsRight?)
			)
			(Format @temp592 {..\\msg\\%d.shm} (curRoom curPic?))
			(shmFile name: @temp592)
			(if (not (shmFile open: 1))
				(= temp604 0)
			else
				(= temp605 0)
				(while (<= temp605 (StrLen @nounStr))
					(if
						(and
							(< 96 (StrAt @nounStr temp605))
							(< (StrAt @nounStr temp605) 123)
						)
						(= temp628 (- (StrAt @nounStr temp605) 32))
						(StrAt @nounStr temp605 temp628)
					)
					(++ temp605)
				)
				(= temp604 0)
				(while
					(!=
						(FileIO fileFGets @temp552 80 (shmFile handle?))
						-1
					)
					(if (not (StrCmp @temp552 {(define} 6))
						(= temp605 0)
						(while (<= temp605 40)
							(= [temp552 temp605] [temp552 (+ temp605 4)])
							(++ temp605)
						)
						(if
						(not (StrCmp @temp552 @nounStr (StrLen @nounStr)))
							(= temp606 0)
							(= temp605 (+ (/ (StrLen @nounStr) 2) 1))
							(while (< temp605 20)
								(= [temp607 temp606] [temp552 temp605])
								(++ temp606)
								(++ temp605)
							)
							(= temp604 (ReadNumber @temp607))
							(break)
						)
					)
					(if (not (StrCmp @temp552 {; CASES})) (break))
				)
				(shmFile close:)
			)
			(= newFeature (Feature new:))
			(newFeature
				init:
				setName: @nameString
				nsLeft: (param1 nsLeft?)
				nsTop: (param1 nsTop?)
				nsBottom: (param1 nsBottom?)
				nsRight: (param1 nsRight?)
				x: (param1 x?)
				y: (param1 y?)
				z: (param1 z?)
				heading: (param1 heading?)
				sightAngle: (param1 sightAngle?)
				approachX: (param1 approachX?)
				approachY: (param1 approachY?)
				noun: temp604
			)
		else
			(Format
				@temp400
				{ \t\tview\t\t\t%d\0D\n\t\tloop\t\t\t%d\0D\n\t\tcel\t\t\t%d\0D\n}
				(param1 view?)
				(param1 loop?)
				(param1 cel?)
			)
		)
		(Format
			@temp440
			{ \t\tapproachX\t\t%d\0D\n\t\tapproachY\t\t%d\0D\n\t\tapproachDist\t%d\0D\n\t\t\_approachVerbs\t$%x\0D\n}
			(param1 approachX?)
			(param1 approachY?)
			(param1 approachDist?)
			(param1 _approachVerbs?)
		)
		(Format
			@temp0
			{ \0D\n(instance %s of %s\0D\n\t(properties\0D\n\t\tx\t\t\t\t\t%d\0D\n\t\ty\t\t\t\t\t%d\0D\n\t\tz\t\t\t\t\t%d\0D\n\t\theading\t\t\t%d\0D\n%s \t\tsightAngle\t\t%d\0D\n%s \t\tnoun\t\t\t\t%s\0D\n\t)\0D\n}
			@nameString
			((param1 -super-?) name?)
			(param1 x?)
			(param1 y?)
			(param1 z?)
			(param1 heading?)
			@temp400
			(param1 sightAngle?)
			@temp440
			@nounStr
		)
		(if toScreen
			(Print
				font: 999
				addText: @temp0
				addTitle: {Feature Writer V1.0}
				init:
			)
		)
		(localproc_0714 @temp0)
		(if hasDoVerb
			(Format
				@temp0
				{ \t(method (doVerb theVerb)\0D\n\t\t(switch theVerb\0D\n}
			)
			(localproc_0714 @temp0)
			(if [vLookStr 0]
				(Format @temp0 { \t\t\t(LOOK\0D\n\t\t\t)\0D\n} @vLookStr)
				(localproc_0714 @temp0)
			)
			(if [vDoStr 0]
				(Format @temp0 { \t\t\t(DO\0D\n\t\t\t)\0D\n} @vDoStr)
				(localproc_0714 @temp0)
			)
			(if [vTalkStr 0]
				(Format @temp0 { \t\t\t(TALK\0D\n\t\t\t)\0D\n} @vTalkStr)
				(localproc_0714 @temp0)
			)
			(Format
				@temp0
				{ \t\t\t(else\0D\n\t\t\t\t(super doVerb: theVerb)\0D\n\t\t\t)\0D\n\t\t)\0D\n\t)\0D\n}
			)
			(localproc_0714 @temp0)
		)
		(StrCpy @temp0 {)\0D\n})
		(localproc_0714 @temp0)
		(if (param1 isMemberOf: Feature)
			(param1 dispose:)
		else
			(param1 addToPic:)
		)
		(file close: dispose:)
		(DisposeScript 993)
		(return (DisposeScript 948))
	)
	
	(method (writeList param1)
		(param1 eachElementDo: #perform self)
		(CreateObject doit:)
		(DisposeScript 948)
	)
)

(instance selectorI of DSelector
	(properties
		x 18
	)
	
	(method (handleEvent pEvent &tmp pEventType pEventMessage)
		(super handleEvent: pEvent)
		(= pEventType (pEvent type?))
		(= pEventMessage (pEvent message?))
		(if
			(or
				(and (== pEventType evMOUSEBUTTON) (pEvent claimed?))
				(and
					(== pEventType evKEYBOARD)
					(== pEventMessage KEY_SPACE)
				)
			)
			(if (== (StrAt cursor 0) 62)
				(StrAt cursor 0 32)
			else
				(StrAt cursor 0 62)
			)
			(self draw:)
			(pEvent claimed: 1)
		)
		(pEvent claimed?)
	)
)

(instance clearBut of DButton
	(properties
		state $0001
		text {Clear}
	)
	
	(method (doit &tmp temp0)
		(= temp0 0)
		(while (< temp0 6)
			(StrAt walkString (* temp0 18) 32)
			(++ temp0)
		)
		(selectorI draw:)
	)
)

(instance allBut of DButton
	(properties
		state $0001
		value 2
		text {__All__}
	)
	
	(method (doit &tmp temp0)
		(= temp0 0)
		(while (< temp0 6)
			(StrAt walkString (* temp0 18) 62)
			(++ temp0)
		)
		(selectorI draw:)
	)
)

(instance doneBut of DButton
	(properties
		value 1
		text { Done_}
	)
)

(instance wfWin of Window
	(properties)
)

(instance shmFile of File
	(properties)
)
