;;; Sierra Script 1.0 - (do not remove this comment)
(script# 180)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	bJack 0
)

(instance bJack of InnRoom
	(properties
		picture 180
		nextRoom 140
		prevRoom 210
	)
	
	(method (init)
		(head init:)
		(theScore init:)
		(myCard
			init:
			ignoreHorizon: 1
			illegalBits: 0
			ignoreActors: 1
		)
		(super init: &rest)
		(self setScript: sBjack)
	)
)

(instance sBjack of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{Or, you can play blackjack with a table of people spread over multiple states,
						and all you have to lose or gain are CasinoBucks.}
					modeless: 1
					init:
				)
				(= seconds 10)
			)
			(2
				(if modelessDialog (modelessDialog dispose:))
				(hit ignoreActors: 1 illegalBits: 0 init:)
				(= cycles 30)
			)
			(3
				(hit dispose:)
				(= cycles 10)
			)
			(4
				(myCard setMotion: MoveTo 22 69 self)
			)
			(5 (= cycles 30))
			(6
				(myCard cel: 1)
				(= cycles 20)
			)
			(7
				(theScore cel: 3)
				(= cycles 30)
			)
			(8
				(bustPlate init:)
				(= seconds 2)
			)
			(9
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance head of Actor
	(properties
		x 9
		y 150
		view 180
	)
)

(instance bustPlate of Prop
	(properties
		x 9
		y 150
		view 180
		cel 1
	)
)

(instance myCard of Actor
	(properties
		x 156
		view 180
		loop 1
		moveSpeed 1
	)
)

(instance hit of Actor
	(properties
		x 82
		y 29
		view 180
		loop 2
		cel 1
	)
)

(instance theScore of Actor
	(properties
		x 34
		y 49
		view 180
		loop 1
		cel 2
	)
)
