;;; Sierra Script 1.0 - (do not remove this comment)
(script# 120)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	boogers 0
)

(instance boogers of InnRoom
	(properties
		picture 120
		style FADEOUT
		nextRoom 130
		prevRoom 110
	)
	
	(method (init)
		(booger init:)
		(super init: &rest)
		(self setScript: sBoogers)
	)
)

(instance sBoogers of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(ambience fade:)
				(= seconds 3)
			)
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{You'll also get to play all kinds of games. And while you're playing,
						you'll make new friends using the on-line live chat feature available
						in most games, as well as in waiting rooms, conference rooms, and chat rooms.}
					modeless: 1
					init:
				)
				(= seconds 5)
			)
			(2
				(SFX number: 790 play:)
				(booger setCycle: EndLoop self)
			)
			(3 (= seconds 4))
			(4 (win init:) (= seconds 5))
			(5
				(win dispose:)
				(= seconds 2)
			)
			(6
				(if modelessDialog (modelessDialog dispose:))
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance booger of Actor
	(properties
		x 141
		y 101
		view 120
	)
)

(instance win of Actor
	(properties
		x 15
		y 5
		view 121
	)
)
