;;; Sierra Script 1.0 - (do not remove this comment)
(script# 140)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	golf 0
)

(instance golf of InnRoom
	(properties
		picture 140
		style FADEOUT
		nextRoom 200
		prevRoom 180
	)
	
	(method (init)
		(char init:)
		(nextGuy init:)
		(person init:)
		(flag init: setCycle: Forward)
		(golfCursor init: setPri: 15)
		(aim init:)
		(feet init:)
		(golfball init:)
		(super init: &rest)
		(self setScript: sGolf)
	)
)

(instance sGolf of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3))
			(1
				(Print
					posn: 90 180
					addText:
						{Play a fun game of golf with your old friend from school, or a new on-line friend.}
					modeless: 1
					init:
				)
				(= seconds 6)
			)
			(2
				(if modelessDialog (modelessDialog dispose:))
				(golfCursor setCycle: EndLoop self)
			)
			(3 (= cycles 10))
			(4 (char setCycle: EndLoop self))
			(5
				(aim cycleSpeed: 6 setCycle: EndLoop self)
			)
			(6
				(aim setLoop: 5 setCycle: EndLoop self)
			)
			(7
				(aim setLoop: 5 setCycle: BegLoop self)
			)
			(8
				(aim setLoop: 5 setCycle: EndLoop self)
			)
			(9
				(aim setLoop: 5 setCycle: BegLoop self)
			)
			(10
				(aim setLoop: 5 setCycle: EndLoop self)
			)
			(11 (person setCycle: EndLoop self))
			(12
				(music number: 3004 play:)
				(person setLoop: 1 setCycle: CycleTo 2 1 self)
			)
			(13
				(SFX number: 3005 play:)
				(person setCycle: EndLoop self)
				(golfball setCycle: EndLoop self)
			)
			(14)
			(15
				(person setLoop: 2 setCycle: EndLoop self)
			)
			(16 (= seconds 2))
			(17
				(chat init: setPri: 15)
				(= seconds 5)
			)
			(18
				(chat dispose:)
				(= seconds 2)
			)
			(19
				(if modelessDialog (modelessDialog dispose:))
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance char of Actor
	(properties
		x 9
		y 121
		view 140
		loop 1
		priority 16
		signal $4010
	)
)

(instance nextGuy of Actor
	(properties
		x 9
		y 121
		view 140
		priority 9
		signal $4010
	)
)

(instance person of Actor
	(properties
		x 127
		y 167
		view 141
		cycleSpeed 2
	)
)

(instance flag of Actor
	(properties
		x 282
		y 36
		view 142
		cel 2
	)
)

(instance golfCursor of Actor
	(properties
		x 181
		y 44
		view 140
		loop 3
	)
)

(instance aim of Actor
	(properties
		x 9
		y 121
		view 140
		loop 4
		cel 14
		priority 15
		signal $0010
	)
)

(instance feet of Actor
	(properties
		x 5
		y 172
		view 140
		loop 2
		priority 1
		signal $0010
	)
)

(instance golfball of Actor
	(properties
		x 164
		y 76
		view 142
		loop 2
	)
)

(instance chat of Actor
	(properties
		x 75
		y 163
		view 143
	)
)
