;;; Sierra Script 1.0 - (do not remove this comment)
(script# 220)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	stratego 0
)

(instance stratego of InnRoom
	(properties
		picture 220
		nextRoom 160
		prevRoom 200
	)
	
	(method (init)
		(piece1 init:)
		(piece2 init:)
		(super init: &rest)
		(self setScript: sStratego)
	)
)

(instance sStratego of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{Or relive your past by playing some of your favorite childhood games.}
					modeless: 1
					init:
				)
				(= seconds 6)
			)
			(2
				(piece1 moveSpeed: 3 setMotion: MoveTo 200 55 self)
			)
			(3
				(piece2 cel: 2 posn: 209 52)
				(= cycles 40)
			)
			(4
				(SFX number: 2261 play:)
				(piece1 setLoop: 1 setCycle: EndLoop self)
			)
			(5
				(piece1 setLoop: 2 setCycle: EndLoop self)
			)
			(6
				(piece1 dispose:)
				(= seconds 2)
			)
			(7
				(if modelessDialog (modelessDialog dispose:))
				(= seconds 2)
			)
			(8
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance piece1 of Actor
	(properties
		x 204
		y 115
		view 220
	)
)

(instance piece2 of Actor
	(properties
		x 200
		y 53
		view 220
		cel 1
	)
)
