;;; Sierra Script 1.0 - (do not remove this comment)
(script# 170)
(include game.sh)
(use Main)
(use InnRoom)
(use Print)
(use Motion)
(use Actor)
(use System)

(public
	trivia 0
)

(local
	local0 =  4
	local1 =  175
)
(instance trivia of InnRoom
	(properties
		picture 170
		nextRoom 210
		prevRoom 130
	)
	
	(method (init)
		(super init: &rest)
		(theTimer init: setCycle: EndLoop)
		(self setScript: sTrivia)
	)
)

(instance sTrivia of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 2))
			(1
				(Print
					width: 290
					posn: -1 180
					addText:
						{Or, playing trivia LIVE with people all over the country.
						NTN Trivia is the same game played in many hotels, restaurants,
						and pubs across the country!}
					modeless: 1
					init:
				)
				(= seconds 10)
			)
			(2
				(if modelessDialog (modelessDialog dispose:))
				(self setScript: doDisplays self)
			)
			(3
				(fun init:)
				(colorLine init:)
				(= seconds 4)
			)
			(4
				(curRoom newRoom: (curRoom nextRoom:))
			)
		)
	)
)

(instance doDisplays of Script
	(properties)
	
	(method (changeState newState)
		(SFX number: 3003 play:)
		(switch (= state newState)
			(0
				(Display {T} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(1
				(Display {h} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(2
				(Display {i} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 3))
				(= cycles 30)
			)
			(3
				(Display {s} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(4
				(Display {} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 3))
				(= cycles 30)
			)
			(5
				(Display {i} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 2))
				(= cycles 30)
			)
			(6
				(Display {s} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(7
				(Display {} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 3))
				(= cycles 30)
			)
			(8
				(Display {t} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(9
				(Display {o} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(10
				(Display {o} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(11
				(Display {} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 3))
				(= cycles 30)
			)
			(12
				(Display {m} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(13
				(Display {u} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(14
				(Display {c} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(15
				(Display {h} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(16
				(Display {} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 3))
				(= cycles 30)
			)
			(17
				(Display {f} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(18
				(Display {u} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 7))
				(= cycles 30)
			)
			(19
				(Display {n} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= cycles 30)
			)
			(20
				(Display {!} p_at local0 local1 p_color 0 p_font 9)
				(= local0 (+ local0 5))
				(= seconds 2)
			)
			(21
				(curRoom drawPic: (curRoom picture?))
				(self dispose:)
			)
		)
	)
)

(instance fun of Actor
	(properties
		x 5
		y 126
		view 170
	)
)

(instance colorLine of Actor
	(properties
		x 224
		y 121
		view 170
		loop 1
	)
)

(instance theTimer of Actor
	(properties
		x 162
		y 11
		view 171
		cycleSpeed 60
	)
)
